# string.cpp File Reference

`#include "stdafx.h"`
`#include "openttd.h"`
`#include "debug.h"`
`#include "core/alloc_func.hpp"`
`#include "string_func.h"`
`#include "table/control_codes.h"`
`#include <stdarg.h>`
`#include <ctype.h>`

Go to the source code of this file.

## Functions
void | ttd_strlcat (char *dst, const char *src, size_t size)
| usage ttd_strlcpy(dst, src, lengthof(dst));
void | ttd_strlcpy (char *dst, const char *src, size_t size)
char * | strecat (char *dst, const char *src, const char *last)
| usage: strecpy(dst, src, lastof(dst));
char * | strecpy (char *dst, const char *src, const char *last)
char *CDECL | str_fmt (const char *str,...)
void | str_validate (char *str)
| Scans the string for valid characters and if it finds invalid ones, replaces them with a question mark '?'.
void | str_strip_colours (char *str)
| Scans the string for colour codes and strips them.
void | strtolower (char *str)
| Convert a given ASCII string to lowercase.
bool | IsValidChar (WChar key, CharSetFilter afilter)
| Only allow certain keys.
char * | md5sumToString (char *buf, const char *last, const uint8 md5sum[16])
| Convert the md5sum to a hexadecimal string representation.
size_t | Utf8Decode (WChar *c, const char *s)
size_t | Utf8Encode (char *buf, WChar c)
size_t | Utf8TrimString (char *s, size_t maxlen)
| Properly terminate an UTF8 string to some maximum length.

## Detailed Description

Definition in file string.cpp.

## Function Documentation

bool IsValidChar | ( | WChar | key,
|  | CharSetFilter | afilter |
| ) |  |  |

Only allow certain keys.

You can define the filter to be used. This makes sure no invalid keys can get into an editbox, like BELL.

Parameters:

  | key | character to be checked
  | afilter | the filter to use

Returns:
  true or false depending if the character is printable/valid or not

Definition at line 145 of file string.cpp.

References CS_ALPHA, CS_ALPHANUMERAL, and CS_NUMERAL.

Referenced by IConsoleCmdExec(), and str_validate().

char* md5sumToString | ( | char * | buf,
|  | const char * | last,
|  | const uint8 | md5sum[16] |
| ) |  |  |

Convert the md5sum to a hexadecimal string representation.

Convert the md5sum number to a 'hexadecimal' string, return next pos in buffer.

Parameters:

  | buf | buffer to put the md5sum into
  | last | last character of buffer (usually lastof(buf))
  | md5sum | the md5sum itself

Returns:
  a pointer to the next character after the md5sum

Definition at line 194 of file string.cpp.

Referenced by IsGoodGRFConfigList().

char* strecat | ( | char * | dst,
|  | const char * | src,
|  | const char * | last |
| ) |  |  |

usage: strecpy(dst, src, lastof(dst));

Parameters:

  | dst | destination buffer
  | src | string to copy
  | last | pointer to the last element in the dst array if NULL no boundary check is performed

Returns:
  a pointer to the terminating in the destination buffer

Definition at line 34 of file string.cpp.

void strtolower | ( | char * | str | ) |

Convert a given ASCII string to lowercase.

Convert the given string to lowercase, only works with ASCII!

NOTE: only support ASCII characters, no UTF8 fancy. As currently the function is only used to lowercase data-filenames if they are not found, this is sufficient. If more, or general functionality is needed, look to r7271 where it was removed because it was broken when using certain locales: eg in Turkish the uppercase 'I' was converted to '?', so just revert to the old functionality

Parameters:

  | str | string to convert

Definition at line 133 of file string.cpp.

Referenced by FioFOpenFile(), and TarListAddFile().

void ttd_strlcat | ( | char * | dst,
|  | const char * | src,
|  | size_t | size |
| ) |  |  |

usage ttd_strlcpy(dst, src, lengthof(dst));

Parameters:

  | dst | destination buffer
  | src | string to copy/concatenate
  | size | size of the destination buffer

Definition at line 16 of file string.cpp.

Referenced by BuildWithFullPath(), DoAutosave(), and GetDebugString().

size_t Utf8TrimString | ( | char * | s,
|  | size_t | maxlen |
| ) |  |  |

Properly terminate an UTF8 string to some maximum length.

Parameters:

  | s | string to check if it needs additional trimming
  | maxlen | the maximum length the buffer can have.

Returns:
  the new length in bytes of the string (eg. strlen(new_string)) maxlen is the string length _INCLUDING_ the terminating ''

Definition at line 288 of file string.cpp.

References Utf8EncodedCharLen().